Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 386416)
+++ channels/chan_sip.c	(working copy)
@@ -29996,7 +29996,7 @@
 			transport = SIP_TRANSPORT_UDP;
 		}
 	} else { /* use default */
-		transport = SIP_TRANSPORT_UDP;
+		transport = default_primary_transport;
 	}
 
 	if (!host) {
@@ -30532,7 +30532,7 @@
 		peer->expire = -1;
 		peer->pokeexpire = -1;
 		peer->keepalivesend = -1;
-		set_socket_transport(&peer->socket, SIP_TRANSPORT_UDP);
+		set_socket_transport(&peer->socket, default_primary_transport);
 	}
 	peer->type = SIP_TYPE_PEER;
 	ast_copy_flags(&peer->flags[0], &global_flags[0], SIP_FLAGS_TO_COPY);
@@ -30765,10 +30765,6 @@
 	}
 	ao2_unlock(peer);
 
-	/* clear the transport information.  We will detect if a default value is required after parsing the config */
-	peer->default_outbound_transport = 0;
-	peer->transports = 0;
-
 	if (!devstate_only) {
 		struct sip_mailbox *mailbox;
 		AST_LIST_TRAVERSE(&peer->mailboxes, mailbox, entry) {
@@ -30816,6 +30812,10 @@
 						peer->default_outbound_transport = peer->transports;
 					}
 				}
+
+				if(!peer->transports) {
+					peer->transports = default_transports;
+				}
 			} else if (realtime && !strcasecmp(v->name, "regseconds")) {
 				ast_get_time_t(v->value, &regseconds, 0, NULL);
 			} else if (realtime && !strcasecmp(v->name, "name")) {
@@ -31237,13 +31237,6 @@
 		}
 	}
 
-	if (!peer->default_outbound_transport) {
-		/* Set default set of transports */
-		peer->transports = default_transports;
-		/* Set default primary transport */
-		peer->default_outbound_transport = default_primary_transport;
-	}
-
 	/* The default transport type set during build_peer should only replace the socket.type when...
 	 * 1. Registration is not present and the socket.type and default transport types are different.
 	 * 2. The socket.type is not an acceptable transport type after rebuilding peer.
